package recitations.recitation5.composites;
import util.annotations.StructurePattern;
@StructurePattern("Bean Pattern")
public class AUniverse implements Universe {
	
	private static final int LINE_X_POS = 30;
	private static final int LINE_Y_POS = 30;
	private static final int LINE_HEIGHT = 0;
	private static final int IMAGE_X_POS = 300;
	private static final int IMAGE_Y_POS = 30;
	private static final int IMAGE_WIDTH = 90;
	private static final int IMAGE_HEIGHT = 170;
	private static final int STRING_Y_POS = 90;
	private static final int STRING_X_POS = 450;
	private static final int LINE_WIDTH = 80;
	
	Line line;
	StringShape text;
	ImageShape image;
	
	public AUniverse (){
		line = new ALine(LINE_X_POS, LINE_Y_POS,LINE_WIDTH,LINE_HEIGHT);
		text = new AStringShape("Hello World!", STRING_X_POS,STRING_Y_POS);
		image = new AShapeImage("shuttle.jpg", IMAGE_X_POS, IMAGE_Y_POS, IMAGE_HEIGHT,IMAGE_WIDTH);
	}	
	
	public Line getLine(){return line;}	
	public StringShape getText(){return text;}
//	@Visible(false)
	public ImageShape getImage(){return image;}
	// try un-commenting below to see what this annotation before a certain method does

	
	public void moveLine(int xOffset, int yOffset){
		line.setX(line.getX() + xOffset);
		line.setY(line.getY() + yOffset);
	}
	
	public void moveText(int xOffset, int yOffset){
		text.setX(text.getX()+xOffset);
		text.setY(text.getY()+yOffset);
	}
	
	public void moveImage(int xOffset, int yOffset){
		image.setX(image.getX()+xOffset);
		image.setY(image.getY()+yOffset);
	}
	
	public void moveAll(int xOffset, int yOffset){
		moveLine(xOffset, yOffset);
		moveText(xOffset, yOffset);
		moveImage(xOffset, yOffset);
	}

}
